﻿Imports System.Runtime.InteropServices

Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Set the ListBox tabs.
        SetListBoxTabs(lstCars, New Integer() {120, 170, 220})

        ' Set the TextBox tabs.
        SetTextBoxTabs(txtCars, New Integer() {120, 170, 220})

        ' Make some data.
        ' Source: http:'www.thesupercars.org/fastest-cars/fastest-cars-in-the-world-top-10-list.
        AddData("SSC Ultimate Aero", 257, 1183, 654400)
        AddData("Bugatti Veyron", 253, 1001, 1700000)
        AddData("Saleen S7 Twin-Turbo", 248, 750, 555000)
        AddData("Koenigsegg CCX", 245, 806, 545568)
        AddData("McLaren F1", 240, 637, 970000)
        AddData("Ferrari Enzo", 217, 660, 670000)
        AddData("Jaguar XJ220", 217, 542, 650000)
        AddData("Pagani Zonda F", 215, 650, 667321)
        AddData("Lamborghini Murcielago LP640", 211, 640, 430000)
        AddData("Porsche Carrera GT", 205, 612, 440000)
    End Sub

    ' Add some data to all three controls.
    Private Sub AddData(ByVal name As String, ByVal mph As Integer, ByVal hp As Integer, ByVal price As Decimal)
        ' Build a tab-delimited string.
        Dim txt As String = name & vbTab & mph.ToString() & " mph" & vbTab & _
            hp.ToString() & " hp" & vbTab & price.ToString("C")

        ' Display in the ListBox and first TextBox.
        lstCars.Items.Add(txt)
        txtCars.Text &= txt & vbCrLf

        ' Display formatted.
        txtFormattedCars.Text &= _
            String.Format("{0,-30}{1,7} mph{2,7} hp{3,15:C}" & vbCrLf, _
            name, mph, hp, price)
    End Sub

    ' Set tab stops inside a ListBox.
    Private Sub SetListBoxTabs(ByVal lst As ListBox, ByVal tabs As IList(Of Integer))
        ' Make sure the control will use them.
        lst.UseTabStops = True
        lst.UseCustomTabOffsets = True

        ' Get the control's tab offset collection.
        Dim offsets As ListBox.IntegerCollection = lstCars.CustomTabOffsets

        ' Define the tabs.
        For Each tab As Integer In tabs
            offsets.Add(tab)
        Next tab
    End Sub


    <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto)> _
    Private Shared Function SendMessage(ByVal hWnd As IntPtr, ByVal Msg As UInteger, ByVal wParam As Integer, ByVal lParam As Integer()) As IntPtr
    End Function

    Private Const EM_SETTABSTOPS As Integer = &HCB

    ' Set tab stops inside a TextBox.
    Private Sub SetTextBoxTabs(ByVal txt As TextBox, ByVal tabs As Integer())
        SendMessage(txt.Handle, EM_SETTABSTOPS, tabs.Length, tabs)
    End Sub
End Class
